import java.awt.*;
import java.awt.event.*;
import java.util.* ;
import java.util.jar.* ;
import java.io.*;

class OmatomekunGUI extends WindowAdapter implements ActionListener {
	Frame frm = new Frame("Omatomekun 2.1");
	Label lb;
	Dialog alert ;
	Checkbox  jpg, tif, bmp, gif, png ;
	Checkbox  logo, hinshitu, name ;
	Label srcLabel ;
	Label outLabel ;
	Label yosouSize ;
 	Choice outFormat ;
	String srcDir ;
	TextField tate ;
	TextField yoko ;
	TextField lines ;
	static ImgFileNameServer fs ;
	OmatomekunConfig config ;
	int NOF ;
	 
	public static void main(String args[]) {
		OmatomekunGUI win = new OmatomekunGUI() ;
	}
	public OmatomekunGUI() {
		frm.setSize(300,200) ;
		frm.setLayout(new GridLayout(7,1)) ;
//		frm.setLayout(new FlowLayout()) ;
		
		Panel pa1=new Panel() ;

		Panel pa0=new Panel() ;

		Panel pa2=new Panel() ;
		Panel pa3=new Panel() ;
		Panel pa4=new Panel() ;
		Panel pa5=new Panel() ;
		Panel pa6=new Panel() ;		
		pa1.setLayout(new GridLayout(1,2)) ;
		pa0.setLayout(new GridLayout(1,1)) ;
		pa2.setLayout(new GridLayout(1,1)) ; 
		pa3.setLayout(new GridLayout(1,1)) ; 
		pa4.setLayout(new GridLayout(1,1)) ; 

		Button load = new Button("fBNgI") ;
		Button run  = new Button("摜Jn") ;
		pa1.add(load) ;
		pa1.add(run ) ;		

		Button sel  = new Button("摜I") ;
		pa0.add(sel) ;

		lb = (Label)pa2.add(new Label("GPL, (c)2006 aurorae, ACR361")) ;
		lb.setSize(300, 200) ;
		
		yoko = new TextField("340");
		tate = new TextField("240");
		jpg = new Checkbox("jpeg",true);
//		tif = new Checkbox("tiff",true);
		gif = new Checkbox("gif",true);
		png = new Checkbox("png",true);
		bmp = new Checkbox("bmp",true);
		logo = new Checkbox("logo}",false);
		srcLabel = (Label)pa3.add(new Label()) ;
		srcLabel.setText("IF");
		pa3.add(jpg) ;
//		pa3.add(tif) ;
		pa3.add(png) ;
		pa3.add(gif) ;
		pa3.add(bmp) ;


		pa5.add(new Label("TCY")) ;
		pa5.add(yoko);
		pa5.add(tate);		
		
		Label outLines = (Label)pa5.add(new Label(" ")) ;
		lines = new TextField("05");
		pa5.add(lines);
//		yosouSize = (Label)pa6.add(new Label("@\zTCYFH")) ;
		
		

		
		
		hinshitu = new Checkbox("i", true);
//		pa4.add(hinshitu) ;
		pa4.add(logo) ;

		Panel pa7=new Panel() ;

		
//		outLabel = (Label)pa4.add(new Label()) ;
//		outLabel.setText("o");		
		outFormat = new Choice();
		outFormat.add("jpg") ;
//		outFormat.add("bmp") ;
//		outFo rmat.add("tiff") ;
		outFormat.add("png") ;
//		outFormat.add("gif") ;
//		pa4.add(outFormat) ;
		pa7.add(new Label("o͌`IF")) ;
		pa7.add(outFormat) ;
				
		name = new Checkbox("t@C", false);
		pa4.add(name) ;
				
		load.addActionListener(this) ;
		run.addActionListener(this)  ;
		sel.addActionListener(this)  ;
		lines.addActionListener(this)  ;
		tate.addActionListener(this)  ;
		yoko.addActionListener(this)  ;

		frm.add(pa1);

		frm.add(pa0);

		frm.add(pa2);
		frm.add(pa5);
		frm.add(pa3);
//		frm.add(pa6);
		frm.add(pa4);
		frm.add(pa7);

		frm.setVisible(true);
		frm.addWindowListener(this);
		
		config = new OmatomekunConfig() ;
		config.init() ;
		fs = new ImgFileNameServer() ;
		fs.ImgFileNameServer(config) ;
		}
	
	public void setString(String e){
		lb.setText(e) ;
		return ;
	}
	
	
	public void actionPerformed(ActionEvent e) {
	
	
		setString(e.getActionCommand());
		
		if(e.getActionCommand() == "摜I"){
			if(config.getSrcDir() == "") {errorDlg("ɃfBNgIĂI"); return; }
			setString("摜I[hɈڍs܂I") ;
			SelectImageGUI si ;
			si = new SelectImageGUI(config, fs, this) ;
			return ;
		}
	
	
		if(e.getActionCommand() == "fBNgI"){
			FileDialog fd = new FileDialog(frm , "\[XfBNgI" , FileDialog.LOAD);
			fd.setVisible(true);
			srcDir = fd.getDirectory() ;
			config.setSrcDir(srcDir) ;
				if(gif.getState()){config.setGif(1);}
				else					config.setGif(0);
				if(png.getState()){config.setPng(1);}
				else					config.setPng(0);
				if(jpg.getState()){config.setJpeg(1);}
				else					config.setJpeg(0);
				if(bmp.getState()){config.setBmp(1);}
				else					config.setBmp(0);
			NOF = (ImgFileNameServer.ImgFileNameServer(config)) ;
			lb.setText(NOF+"files:"+fd.getDirectory()) ;
			config.setSentaku(0) ;
			fs.resetConfig(config) ;
			return ;
		}
		else{
			if (e.getActionCommand() == "OK") {
			alert.dispose() ;
			return ;
			}
			else if(e.getActionCommand() == "摜Jn"){
				config.setSrcDir(srcDir) ;
				if((Integer.valueOf(tate.getText()).intValue() > 1)) config.setTate(Integer.valueOf(tate.getText()).intValue()) ;
				else										config.setTate(240) ;
				if((Integer.valueOf(yoko.getText()).intValue() > 1)) config.setYoko(Integer.valueOf(yoko.getText()).intValue()) ;
				else																	config.setYoko(320) ;
				if((Integer.valueOf(lines.getText()).intValue() > 0)) config.setLines(Integer.valueOf(lines.getText()).intValue()) ;
				else																	config.setLines(5) ;
				if(gif.getState()){config.setGif(1);}
				else					config.setGif(0);
				if(png.getState()){config.setPng(1);}
				else					config.setPng(0);
				if(jpg.getState()){config.setJpeg(1);}
				else					config.setJpeg(0);
				if(bmp.getState()){config.setBmp(1);}
				else					config.setBmp(0);
				if(! jpg.getState() && ! png.getState() && !gif.getState() && !bmp.getState()) return ;
				if(logo.getState()){config.setLogo(1);}
				else					config.setLogo(0);
				if(name.getState()){config.setName(1);}
				else					config.setName(0);	
				config.setOutFormat(outFormat.getSelectedItem());

				
				String hozonji="ۑIFjpegł̐(ő)";
				if(hinshitu.getState()){
					config.setHinshitu(1);
//					hinshituCK();
					hozonji = "idŏ܂B"+ hozonji ;
				}
				else{
					config.setHinshitu(0);
					hozonji = "xdŏ܂B"+ hozonji ;
				}
				
				FileDialog fd = new FileDialog(frm ,
				hozonji+(int)(
					0.00014*2
					*(
						(double)config.getTate() 
						*(double)config.getYoko() 
					) 
					*(
						(double)(fs.getSelectedImgFileNumber())
						+
						(double)config.getLines()
					)
				)+"KB" , FileDialog.SAVE);
				fd.setVisible(true);
				
				String kakuchoushi = fd.getFile() ;
				System.out.println(kakuchoushi);
				try{if(kakuchoushi.charAt(kakuchoushi.length()-4)!= '.' && kakuchoushi.charAt(kakuchoushi.length()-5) != '.') kakuchoushi = kakuchoushi+ "." +outFormat.getSelectedItem();}
				catch(Exception ddde){kakuchoushi=kakuchoushi+"."+outFormat.getSelectedItem();}
				config.setOutFile(fd.getDirectory()+kakuchoushi) ;
				try{if(fd.getFile().length()<1){
						System.out.println(fd.getFile().length()) ;
						return ;}
				}
				catch(Exception hoge){return ;}
				Omatomekun tmp = new Omatomekun() ;
				tmp.Omatomekun(config,fs) ;
				try{
					tmp.omatomechu(this);
				}
				catch(Exception er){
					errorDlg("G[B炭javaK胁słB\n邽߂ɂ̓t@C̐炷A"+
					"R}hCjart@ĈtH_܂ňړ\n"+
					"java -Xmx512m -jar Omatomekun.jarƓ͂ĂB\n"+
					"mۗʂ𑝂₷Ƃo܂BR[h-4\n"+
					"G[ڍׁF"+er
					);
				}
				
//				setConfig();
//				omatomekunRun();
			}
			else{
				if(e.getActionCommand() == "i") hinshituCK() ;
				}
			}
		
	}
	
	public void windowClosing(WindowEvent e) {
		System.exit(0);
	}
	
	private void waring() {
		alert = new Dialog(new Frame() , "G[I") ;
		alert.setLayout(new GridLayout(2 , 1));
		alert.add(new Label("datt@CIĂ܂B"+tif.getState())) ;
		Button but = (Button)alert.add(new Button("OK"));
		but.addActionListener(this) ;
		alert.setSize(300 , 150);
		alert.setVisible(true);

		alert.addWindowListener(this);
	}
	
	private void hinshituCK() {
		alert = new Dialog(new Frame() , "xɂ") ;
		alert.setLayout(new GridLayout(2 , 1));
		alert.add(new Label("gkɕid邽ߎԂ܂B")) ;
		Button but = (Button)alert.add(new Button("OK"));
		but.addActionListener(this) ;
		alert.setSize(200 , 100);
		alert.setVisible(true);
		
		frm.setSize(261,148) ;
		
		
		alert.addWindowListener(this);
	}	
	public void errorDlg(String e){
		alert = new Dialog(new Frame() , "G[I") ;
		alert.setLayout(new GridLayout(2 , 1));
		alert.add(new TextArea(e)) ;
		Button but = (Button)alert.add(new Button("OK"));
		but.addActionListener(this) ;
		alert.setSize(400 , 600);
		alert.setVisible(true);	
	}
	
	
	
	
}